/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	scheme "quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

// NetAppClusterPeeringsGetter has a method to return a NetAppClusterPeeringInterface.
// A group's client should implement this interface.
type NetAppClusterPeeringsGetter interface {
	NetAppClusterPeerings(namespace string) NetAppClusterPeeringInterface
}

// NetAppClusterPeeringInterface has methods to work with NetAppClusterPeering resources.
type NetAppClusterPeeringInterface interface {
	Create(ctx context.Context, netAppClusterPeering *v1alpha1.NetAppClusterPeering, opts v1.CreateOptions) (*v1alpha1.NetAppClusterPeering, error)
	Update(ctx context.Context, netAppClusterPeering *v1alpha1.NetAppClusterPeering, opts v1.UpdateOptions) (*v1alpha1.NetAppClusterPeering, error)
	UpdateStatus(ctx context.Context, netAppClusterPeering *v1alpha1.NetAppClusterPeering, opts v1.UpdateOptions) (*v1alpha1.NetAppClusterPeering, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NetAppClusterPeering, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NetAppClusterPeeringList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppClusterPeering, err error)
	NetAppClusterPeeringExpansion
}

// netAppClusterPeerings implements NetAppClusterPeeringInterface
type netAppClusterPeerings struct {
	client rest.Interface
	ns     string
}

// newNetAppClusterPeerings returns a NetAppClusterPeerings
func newNetAppClusterPeerings(c *QuarkV1alpha1Client, namespace string) *netAppClusterPeerings {
	return &netAppClusterPeerings{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the netAppClusterPeering, and returns the corresponding netAppClusterPeering object, and an error if there is any.
func (c *netAppClusterPeerings) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NetAppClusterPeering, err error) {
	result = &v1alpha1.NetAppClusterPeering{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NetAppClusterPeerings that match those selectors.
func (c *netAppClusterPeerings) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NetAppClusterPeeringList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NetAppClusterPeeringList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested netAppClusterPeerings.
func (c *netAppClusterPeerings) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a netAppClusterPeering and creates it.  Returns the server's representation of the netAppClusterPeering, and an error, if there is any.
func (c *netAppClusterPeerings) Create(ctx context.Context, netAppClusterPeering *v1alpha1.NetAppClusterPeering, opts v1.CreateOptions) (result *v1alpha1.NetAppClusterPeering, err error) {
	result = &v1alpha1.NetAppClusterPeering{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppClusterPeering).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a netAppClusterPeering and updates it. Returns the server's representation of the netAppClusterPeering, and an error, if there is any.
func (c *netAppClusterPeerings) Update(ctx context.Context, netAppClusterPeering *v1alpha1.NetAppClusterPeering, opts v1.UpdateOptions) (result *v1alpha1.NetAppClusterPeering, err error) {
	result = &v1alpha1.NetAppClusterPeering{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		Name(netAppClusterPeering.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppClusterPeering).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *netAppClusterPeerings) UpdateStatus(ctx context.Context, netAppClusterPeering *v1alpha1.NetAppClusterPeering, opts v1.UpdateOptions) (result *v1alpha1.NetAppClusterPeering, err error) {
	result = &v1alpha1.NetAppClusterPeering{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		Name(netAppClusterPeering.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppClusterPeering).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the netAppClusterPeering and deletes it. Returns an error if one occurs.
func (c *netAppClusterPeerings) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *netAppClusterPeerings) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched netAppClusterPeering.
func (c *netAppClusterPeerings) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppClusterPeering, err error) {
	result = &v1alpha1.NetAppClusterPeering{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("netappclusterpeerings").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
