/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppVolumeLister helps list NetAppVolumes.
// All objects returned here must be treated as read-only.
type NetAppVolumeLister interface {
	// List lists all NetAppVolumes in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolume, err error)
	// NetAppVolumes returns an object that can list and get NetAppVolumes.
	NetAppVolumes(namespace string) NetAppVolumeNamespaceLister
	NetAppVolumeListerExpansion
}

// netAppVolumeLister implements the NetAppVolumeLister interface.
type netAppVolumeLister struct {
	indexer cache.Indexer
}

// NewNetAppVolumeLister returns a new NetAppVolumeLister.
func NewNetAppVolumeLister(indexer cache.Indexer) NetAppVolumeLister {
	return &netAppVolumeLister{indexer: indexer}
}

// List lists all NetAppVolumes in the indexer.
func (s *netAppVolumeLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolume, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolume))
	})
	return ret, err
}

// NetAppVolumes returns an object that can list and get NetAppVolumes.
func (s *netAppVolumeLister) NetAppVolumes(namespace string) NetAppVolumeNamespaceLister {
	return netAppVolumeNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppVolumeNamespaceLister helps list and get NetAppVolumes.
// All objects returned here must be treated as read-only.
type NetAppVolumeNamespaceLister interface {
	// List lists all NetAppVolumes in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolume, err error)
	// Get retrieves the NetAppVolume from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppVolume, error)
	NetAppVolumeNamespaceListerExpansion
}

// netAppVolumeNamespaceLister implements the NetAppVolumeNamespaceLister
// interface.
type netAppVolumeNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppVolumes in the indexer for a given namespace.
func (s netAppVolumeNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolume, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolume))
	})
	return ret, err
}

// Get retrieves the NetAppVolume from the indexer for a given namespace and name.
func (s netAppVolumeNamespaceLister) Get(name string) (*v1alpha1.NetAppVolume, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappvolume"), name)
	}
	return obj.(*v1alpha1.NetAppVolume), nil
}
